Subject: Re: [1.8.0] reorganize the mess that the source tree has become

From: Thomas Rast <[email-masked]>
Date: Tue, 1 Feb 2011 13:42:06 +0100

Nicolas Pitre wrote:
> What I see in the root of the Git source 
> tree is a huge clutter of source files, binary files, scripts, and 
> subdirectories all mixed together.  If you know by hart where things are 
> because you've been hacking on them for the last 5 years then of course 
> you might not see the point.  But since I didn't work much on Git 
> lately, things are not as obvious to me as they used to be.  Looking 
> back at it now with some distance, this tree looks like a mess and it is 
> really annoying to work with.

But judging by that assessment, shouldn't we strive to make it
*easier* to find things?

In particular a prospective git hacker would not care whether
something is a source file or a script (you seem to imply the
opposite).  He would instead expect to find git-foo implemented in
something named of that sort, so we could probably help him by mapping

  git-foo.sh      ->   git-foo.sh
  builtin/bar.c   ->   git-bar.c
  baz.c           ->   lib/baz.c
  baz.o           ->   build/baz.o (or whatever, just elsewhere)
  baz.gcov        ->   build/baz.gcov (ditto)

(I'm no huge fan of src/ either, but this should be orthogonal.)

-- 
Thomas Rast
trast@{inf,student}.ethz.ch